/* Speed measuring for modular functions.

   Copyright 2002, 2007 Kevin Ryde

   This file is part of MPM.

   MPM is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2, or (at your option) any later version.

   MPM is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with MPM; see the file COPYING.  If not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
   USA.  */


#define SPEED_EXTRA_PROTOS                                                    \
  double speed_mpr_add __GMP_PROTO ((struct speed_params *s));                \
  double speed_mpr_div __GMP_PROTO ((struct speed_params *s));                \
  double speed_mpr_invert __GMP_PROTO ((struct speed_params *s));             \
  double speed_mpr_mul __GMP_PROTO ((struct speed_params *s));                \
  double speed_mpr_sub __GMP_PROTO ((struct speed_params *s));                \
  double speed_mpn_mullowhalf_basecase __GMP_PROTO ((struct speed_params *s)); \
  double speed_mpn_mullowhalf_kara __GMP_PROTO ((struct speed_params *s));    \
  double speed_mpn_mullowhalf_n __GMP_PROTO ((struct speed_params *s));       \

#define SPEED_EXTRA_ROUTINES                                    \
  { "mpr_add",    speed_mpr_add,    FLAG_R },                   \
  { "mpr_div",    speed_mpr_div,    FLAG_R },                   \
  { "mpr_invert", speed_mpr_invert, FLAG_R },                   \
  { "mpr_mul",    speed_mpr_mul,    FLAG_R },                   \
  { "mpr_sub",    speed_mpr_sub,    FLAG_R },                   \
  { "mpn_mullowhalf_basecase", speed_mpn_mullowhalf_basecase }, \
  { "mpn_mullowhalf_kara",     speed_mpn_mullowhalf_kara },     \
  { "mpn_mullowhalf_n",        speed_mpn_mullowhalf_n },        \

#include "tune/speed.c"
